/*
 * TLC5940.h
 *
 *  Created on: 2021830
 *      Author: admin
 */

#ifndef INC_TLC5940_H_
#define INC_TLC5940_H_

#include "main.h"
//#include "stm32f4xx_hal_def.h"

#define BLANK_PIN                  GPIO_PIN_9
#define BLANK_GPIO_PORT            GPIOA
#define BLANK_GPIO_CLK             RCC_AHB1Periph_GPIOA

#define TLC5940_BLANK(a)	if (a)	\
					HAL_GPIO_WritePin(BLANK_GPIO_PORT,BLANK_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(BLANK_GPIO_PORT,BLANK_PIN,GPIO_PIN_RESET)

#define DCPRG_PIN                  GPIO_PIN_2
#define DCPRG_GPIO_PORT            GPIOA
#define DCPRG_GPIO_CLK             RCC_AHB1Periph_GPIOA

#define TLC5940_DCPRGK(a)	if (a)	\
					HAL_GPIO_WritePin(DCPRG_GPIO_PORT,DCPRG_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(DCPRG_GPIO_PORT,DCPRG_PIN,GPIO_PIN_RESET)

#define XLAT_PIN                  GPIO_PIN_3
#define XLAT_GPIO_PORT            GPIOD
#define XLAT_GPIO_CLK             RCC_AHB1Periph_GPIOD

#define TLC5940_XLAT(a)	if (a)	\
					HAL_GPIO_WritePin(XLAT_GPIO_PORT,XLAT_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(XLAT_GPIO_PORT,XLAT_PIN,GPIO_PIN_RESET)

#define SCLK_PIN                  GPIO_PIN_10
#define SCLK_GPIO_PORT            GPIOA
#define SCLK_GPIO_CLK             RCC_AHB1Periph_GPIOA

#define TLC5940_SCLK(a)	if (a)	\
					HAL_GPIO_WritePin(SCLK_GPIO_PORT,SCLK_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(SCLK_GPIO_PORT,SCLK_PIN,GPIO_PIN_RESET)

#define SOUT_PIN                  GPIO_PIN_4
#define SOUT_GPIO_PORT            GPIOA
#define SOUT_GPIO_CLK             RCC_AHB1Periph_GPIOA

#define TLC5940_SOUT(a)	if (a)	\
					HAL_GPIO_WritePin(SOUT_GPIO_PORT,SOUT_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(SOUT_GPIO_PORT,SOUT_PIN,GPIO_PIN_RESET)

#define GSCLK_PIN                  GPIO_PIN_5
#define GSCLK_GPIO_PORT            GPIOD
#define GSCLK_GPIO_CLK             RCC_AHB1Periph_GPIOD

#define TLC5940_GSCLK(a)	if (a)	\
					HAL_GPIO_WritePin(GSCLK_GPIO_PORT,GSCLK_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(GSCLK_GPIO_PORT,GSCLK_PIN,GPIO_PIN_RESET)

#define SIN_PIN                  GPIO_PIN_10
#define SIN_GPIO_PORT            GPIOB
#define SIN_GPIO_CLK             RCC_AHB1Periph_GPIOB

#define TLC5940_SIN(a)	if (a)	\
					HAL_GPIO_WritePin(SIN_GPIO_PORT,SIN_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(SIN_GPIO_PORT,SIN_PIN,GPIO_PIN_RESET)

#define XERR_PIN                  GPIO_PIN_3
#define XERR_GPIO_PORT            GPIOA
#define XERR_GPIO_CLK             RCC_AHB1Periph_GPIOA

#define TLC5940_XERR(a)	if (a)	\
					HAL_GPIO_WritePin(XERR_GPIO_PORT,XERR_PIN,GPIO_PIN_SET);\
					else		\
					HAL_GPIO_WritePin(XERR_GPIO_PORT,XERR_PIN,GPIO_PIN_RESET)

extern unsigned char PWMtable[24];

extern void Refresh();
extern void EnableAllPWM();
extern void DisableAllPWM();
extern void WriteXBit(unsigned char* pWriteData, unsigned char bitNumber);

#endif /* INC_TLC5940_H_ */
